## debian-cd 3.2.0

=== debian/changelog ===
debian-cd (3.2.0) unstable; urgency=medium

  [ Cyril Brulebois — high-level summary ]
  * This release implements many changes related to the 2022 General
    Resolution about non-free firmware. In particular, this means adding
    metadata related to firmware packages, allowing hw-detect to configure
    apt-setup according to firmware packages getting deployed. In the
    general case, systems installed using netinst should only get main and
    non-free-firmware (if such firmware packages are needed) configured,
    without contrib or non-free.
  * Builds involving local packages (LOCAL and LOCALDEBS settings) were
    also reworked. This feature is not used for official builds, and some
    catch-up was needed (apt becomes stricter over time). The expected
    layout for local packages was clarified (see comments in CONF.sh), and
    while it is expected to be clearer and better than it was, it might
    require some local adjustments.

  [ Cyril Brulebois ]
  * CONF.sh (and README):
     + Clarify expected layout below the LOCALDEBS directory.
     + Clarify relationships between NONFREE, NONFREE_COMPONENTS, and
       FORCE_FIRMWARE.
     + Keep only non-free-firmware in NONFREE_COMPONENTS, as the
       interesting firmware packages have been moved from non-free to
       non-free-firmware.
     + Unset CONTRIB for consistency: NONFREE is unset, and packages in
       contrib are usually there because they depend on packages in
       non-free.
  * apt-selection:
     + Annotate local repositories with [trusted=yes].
  * easy-build.sh (and Packages-gen):
     + Create top-level Release files for local packages, allowing apt to
       validate Packages files (when UPDATE_LOCAL=1 is set).
     + Create both compressed and uncompress Packages files: apt is
       unhappy if uncompressed files are missing; the package indexing
       done in various places is unhappy if compressed files are missing.
  * generate_firmware_patterns:
     + Refresh modalias information for the firmware-sof-signed package
       (using linux-image-6.1.0-1-amd64 version 6.1.4-1).
     + Make sure dep11 metadata files are present.
     + Rewrite to work on a single package at once (working on ALL was
       mostly interesting during early development).
  * generate_firmware_tasks:
     + Search for firmware packages only in the configured components,
       instead of searching in all available components. This means main
       in any case, while contrib, non-free, and non-free-firmware depend
       on the CONTRIB, NONFREE, NONFREE_COMPONENTS, and related variables.
     + Implement support for pseudo-option --list-filenames, making the
       firmware package search reusable.
  * make-firmware-image:
     + Use generate_firmware_task to find firmware packages.
     + Implement firmware/dep11 generation for bookworm and later. This
       tool is responsible for generating the firmware tarball, zip, and
       cpio archives that can be used to extend installation media which
       don't contain firmware packages. This allows hw-detect to benefit
       from the same metadata as found in e.g. the netinst image.
  * make_disc_trees.pl:
     + Add leading / to paths in Contents-firmware indices, making it
       easier to use by hw-detect.
     + Add component column to Contents-firmware indices, making it
       possible for hw-detect to set the right apt-setup/$component
       parameters.
     + Store $package.component files alongside $package.patterns files
       for firmware packages, also to help hw-detect.
     + Create /firmware before adding symlinks, and error out if symlink
       creation fails.
     + Improve block calculation for firmware-related metadata files.
     + Merge “local” udebs into “main” explicitly.
     + Rewrite .disk/base_components if needed: setting LOCAL=1 results
       in debootstrap's being called with --components=main,local while
       there might be no debs on the image (depending on the contents of
       the LOCALDEBS directory)… in that case, rewrite base_components
       without “local”.
  * start_new_disc:
     + Remove /dists/local commodity symlink: it's unclear what it is or
       was useful for, and it generated a lot of confusion during this
       development cycle (local = component or codename?!), masking other
       shortcomings.
  * Replace all gzip -9 variations with pigz -9nm ones.
  * Add pigz to Depends accordingly.
  * Add uuid-runtime to Depends (missed in 3.1.36).

  [ Samuel Thibault ]
  * Fix missing %install% replacements, fixing support for automatically
    starting a specific entry when a timeout is reached.

  [ Steve McIntyre ]
  * make-firmware-image: Add a list file to show what's included in
    the firmware archives.
  * Add new config option DISABLE_UEFI_32 to control mixed-mode EFI on
    x86 builds. Closes: #1031424
  * Add iucode-tool to the list of base packages wanted for amd64 and
    i386, so we will have it available for installing CPU microcode.

 -- Cyril Brulebois <kibi@debian.org>  Fri, 24 Feb 2023 17:04:14 +0100

## debian-cd 3.2.1

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for debian-cd
#
# Copyright 1999 Raphaël Hertzog <hertzog@debian.org>
# See the README file for the license
#
# Significantly modified 2005-2006 Steve McIntyre <93sam@debian.org>
# for multi-arch and mixed bin/src discs
#
# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef TASK
TASK=Debian-generic
endif
ifndef MKISOFS
ifneq (,$(filter i386 amd64 arm64 hppa,$(ARCHES)))
export MKISOFS=xorriso
export MKISOFS_OPTS=-as mkisofs -r -checksum_algorithm_iso sha256,sha512
else
export MKISOFS=$(shell which genisoimage mkisofs | head -1)
endif
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r
#For symlink farmers
#MKISOFS_OPTS=-r -F .
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifndef ARCHIVE_KEYRING_PACKAGE
ARCHIVE_KEYRING_PACKAGE=debian-archive-keyring
endif
ifndef ARCHIVE_KEYRING_FILE
ARCHIVE_KEYRING_FILE=usr/share/keyrings/debian-archive-keyring.gpg
endif
ifndef JIGDO_CHECKSUM
JIGDO_CHECKSUM=md5
endif

export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
ifeq ($(ARCHES),source)
	export SOURCEONLY=yes
endif
ifeq ($(shell echo $(ARCHES) | sed 's/.*source.*/1/'),1)
	export INC_SOURCE=yes
endif

UNDER_ARCHES=$(shell echo $(ARCHES) | sed 's/\ /_/g')
ARCH_MKISOFS = ${${UNDER_ARCHES}_MKISOFS}
ARCH_MKISOFS_OPTS = ${${UNDER_ARCHES}_MKISOFS_OPTS}
ifneq (${ARCH_MKISOFS},)
    MKISOFS = ${ARCH_MKISOFS}
endif
ifneq (${ARCH_MKISOFS_OPTS},)
    MKISOFS_OPTS = ${ARCH_MKISOFS_OPTS}
endif
ifndef DEBOOTSTRAP_OPTS
DEBOOTSTRAP_OPTS=--no-check-gpg
endif

## Additional packages required for Debian Ports
DEBIAN_PORTS_ARCHES=alpha hppa ia64 hurd-i386 m68k powerpc powerpcspe ppc64 riscv64 sh4 sparc sparc64 x32
ifneq (,$(filter $(DEBIAN_PORTS_ARCHES),$(ARCHES)))
export BASE_INCLUDE := $(BASEDIR)/data/debian_ports $(BASE_INCLUDE)
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
check_backports_packages=$(BASEDIR)/tools/check_backports_packages
sort_deps=$(BASEDIR)/tools/sort_deps
md5sum=md5sum
jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
grab_checksums=$(BASEDIR)/tools/grab_checksums
make_image=$(BASEDIR)/tools/make_image
merge_package_lists=$(BASEDIR)/tools/merge_package_lists
update_popcon=$(BASEDIR)/tools/update_popcon
grab_source_list=$(BASEDIR)/tools/grab_source_list
which_deb=$(BASEDIR)/tools/which_deb
catz=$(BASEDIR)/tools/catz

BDIR=$(TDIR)/$(CODENAME)
TASKDIR=$(BDIR)/tasks
ADIR=$(APTTMP)
DB_DIR=$(BDIR)/debootstrap

export DEBOOTSTRAP_DIR := $(DB_DIR)/usr/share/debootstrap
export PATH := $(DB_DIR)/usr/sbin:$(PATH)
export BDIR
export TASKDIR

## DEBUG STUFF ##

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

## CHECKS ##

# Basic checks in order to avoid problems
ok:
ifdef FORCE_FAIL
	@echo Debug variable FORCE_FAIL defined -- abort now; false
endif
ifndef TDIR
	@echo TDIR undefined -- set up CONF.sh; false
endif
ifndef BASEDIR
	@echo BASEDIR undefined -- set up CONF.sh; false
endif
ifndef MIRROR
	@echo MIRROR undefined -- set up CONF.sh; false
endif
ifndef ARCHES
	@echo ARCHES undefined -- set up CONF.sh; false
endif
ifndef CODENAME
	@echo CODENAME undefined -- set up CONF.sh; false
endif
ifndef DISKTYPE
	@echo DISKTYPE undefined -- set up CONF.sh; false
endif
ifndef OUT
	@echo OUT undefined -- set up CONF.sh; false
endif
ifdef NONFREE
ifdef EXTRANONFREE
	@echo Never use NONFREE and EXTRANONFREE at the same time; false
endif
endif
	@if [ $(DISKTYPE) = "NETINST" -o $(DISKTYPE) = "BC" ] ; then \
		if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
			echo "Including source is not supported on a netinst/bc CD"; \
			false; \
		fi; \
	fi

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(TASKDIR) $(BDIR)/DATE $(DB_DIR) unstable-map
$(OUT):
	$(Q)mkdir -p $(OUT)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
$(TASKDIR):
ifneq ($(ARCHES),source)
	$(Q)echo "Updating task files..."
	$(Q)mkdir -p $(TASKDIR)
	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
	$(Q)echo "- generating dynamic task files"
	$(Q)set -e; cd $(TASKDIR); \
		$(BASEDIR)/tools/update_tasks; \
		$(BASEDIR)/tools/generate_di_list; \
		$(BASEDIR)/tools/generate_di+k_list
ifeq ($(FORCE_FIRMWARE),1)
	# Generate firmware task file using the contents of the archive
	$(Q)$(BASEDIR)/tools/generate_firmware_task "$(ARCHES)" $(TASKDIR)/firmware
endif
ifeq ($(DEBIAN_EDU),1)
	# Generate Debian Edu task file containing (almost) all of Debian Edu's packages
	$(Q)$(BASEDIR)/tools/generate_debian-edu_task "$(ARCHES)" $(TASKDIR)/debian-edu-full
endif
endif
$(BDIR)/DATE:
	$(Q)date -u '+%Y%m%d' > $(BDIR)/DATE
	$(Q)date -u '+%Y%m%dT%H%M%SZ' --date tomorrow > $(BDIR)/DATE-zulu

ifdef MIRROR
LATEST_DB := $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) debootstrap)
$(DB_DIR): $(LATEST_DB)
	@rm -rf $(DB_DIR)
	$(Q)dpkg -x $(LATEST_DB) $(DB_DIR)
	$(Q)if [ ! -e $(DEBOOTSTRAP_DIR)/scripts/$(CODENAME) ] ; then \
		ln -sf sid $(DEBOOTSTRAP_DIR)/scripts/$(CODENAME) ; \
	fi
endif

# Make sure unstable/sid points to testing/bookworm, as there is no build
# rule for unstable/sid.
unstable-map:
	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
		ln -s bookworm $(BASEDIR)/data/sid ; \
	fi
	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
		ln -s bookworm $(BASEDIR)/tools/boot/sid ; \
	fi

#################
## CLEAN RULES ##
#################

# Cleans the current arch tree (but not packages selection info)
clean: ok dir-clean
dir-clean:
	$(Q)rm -rf $(BDIR)/CD[1234567890]*
	$(Q)rm -rf $(TASKDIR)
	$(Q)rm -f $(BDIR)/*.filelist*
	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/upgrade-stamp $(BDIR)/checksum-check

# Completely cleans the current arch tree
realclean: distclean
distclean: ok clean
	$(Q)echo "Cleaning the build directory"
	$(Q)rm -rf $(ADIR)
	$(Q)rm -rf $(TDIR)

####################
## STATUS and APT ##
####################

$(CODENAME)_status: ok init
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		echo "Using the provided status file for $(CODENAME)-$$ARCH ..."; \
		cp $(BASEDIR)/data/$(CODENAME)/status.$$ARCH $(ADIR)/$(CODENAME)-$$ARCH/status 2>/dev/null || $(MAKE) status || $(MAKE) correctstatus ; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			echo "Using the provided status file for $(CODENAME)-backports-$$ARCH ..."; \
			cp $(BASEDIR)/data/$(CODENAME)/status.$$ARCH $(ADIR)/$(CODENAME)-backports-$$ARCH/status 2>/dev/null || $(MAKE) status || $(MAKE) correctstatus ; \
		fi; \
	done

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)for ARCH in $(ARCHES); do \
		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/preferences.d; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			mkdir -p $(ADIR)/$(CODENAME)-backports-$$ARCH/apt/preferences.d; \
		fi; \
		if [ $$ARCH = "source" -o "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" -o "$(INSTALLER_CD)" = "C" -o "$(INSTALLER_CD)" = "F" ];then \
			:> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
			if [ "$$BACKPORTS"x != ""x ] ; then \
				:> $(ADIR)/$(CODENAME)-backports-$$ARCH/status ; \
			fi; \
		else \
			$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
			if [ "$$BACKPORTS"x != ""x ] ; then \
				$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
				perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
				>> $(ADIR)/$(CODENAME)-backports-$$ARCH/status ; \
			fi; \
		fi; \
	done;
	:> $(ADIR)/status

	# Set up keyring so apt doesn't complain
	@echo "Setting up archive-keyring"
	$(Q)mkdir -p $(TDIR)/archive-keyring
	$(Q)dpkg -x $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) $(ARCHIVE_KEYRING_PACKAGE)) $(TDIR)/archive-keyring
	$(Q)for ARCH in $(ARCHES); do \
		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
		ln -s $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
		for key in $(ARCHIVE_EXTRA_KEYS); do \
			gpg --export -a $$key >> $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d/$$key.asc; \
		done; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			mkdir -p $(ADIR)/$(CODENAME)-backports-$$ARCH/apt/trusted.gpg.d; \
			ln -s $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-backports-$$ARCH/apt/trusted.gpg.d; \
		fi; \
	done

	# Updating the apt database
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) update; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			USE_BP=1 $(apt) update; \
		fi; \
	done

	# If we're doing a build using d-i from sid, we'll need sid sources too
	if [ "$(INC_SOURCE)"x = "yes"x ] && \
		[ "$(DI_CODENAME)"x != ""x ] && \
		[ "$(DI_CODENAME)"x != "$(CODENAME)"x ] ; then \
		mkdir -p $(ADIR)/$(DI_CODENAME)-source/apt/preferences.d ; \
		:> $(ADIR)/$(DI_CODENAME)-source/status ; \
		export CODENAME=$(DI_CODENAME); \
		export ARCH=source; \
		$(apt) update; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			USE_BP=1 $(apt) update; \
		fi; \
	fi
    #
    # Checking the consistency of the standard system
    # If this does fail, then launch make correctstatus
    #
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) check || $(MAKE) correctstatus; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			USE_BP=1 $(apt) check || $(MAKE) correctstatus; \
		fi; \
	done

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
    # You may need to launch correctstatus more than one time
    # in order to correct all dependencies
    #
    # Removing packages from the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) deselected -f install`; do \
				echo $$ARCH:$$i; \
				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
				$(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
			if [ "$$BACKPORTS"x != ""x ] ; then \
				for i in `USE_BP=1 $(apt) deselected -f install`; do \
					echo $$ARCH:$$i; \
					perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
					$(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
				done; \
			fi; \
		done; \
    fi
    #
    # Adding packages to the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) selected -f install`; do \
				echo $$ARCH:$$i; \
				$(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
			if [ "$$BACKPORTS"x != ""x ] ; then \
				for i in `USE_BP=1 $(apt) selected -f install`; do \
					echo $$ARCH:$$i; \
					USE_BP=1 $(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
					"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
					>> $(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
				done; \
			fi; \
		done; \
    fi
    #
    # Showing the output of apt-get check :
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(apt) check; \
		if [ "$$BACKPORTS"x != ""x ] ; then \
			USE_BP=1 ARCH=$$ARCH $(apt) check; \
		fi; \
	done

apt-update: status
	$(Q)if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES); do \
			echo "Apt-get is updating its files ..."; \
			ARCH=$$ARCH $(apt) update; \
			if [ "$$BACKPORTS"x != ""x ] ; then \
				USE_BP=1 ARCH=$$ARCH $(apt) update; \
			fi; \
		done; \
    fi

=== debian/changelog ===
debian-cd (3.2.1) unstable; urgency=medium

  [ James Addison ]
  * firmware: use hard links rather than symlinks. Closes: #1031696

  [ Steve McIntyre ]
  * Kill loadlin, nobody has DOS any more. Also Stop copying the
    /tools directory from the mirror, as that's all that's left there
    now.

  [ Cyril Brulebois ]
  * tools/generate_di+k_list: Add zstd alongside initramfs-tools and
    busybox, since it's now getting installed by base-installer (starting
    with 1.212).

 -- Cyril Brulebois <kibi@debian.org>  Sun, 30 Apr 2023 18:11:17 +0200

## debian-cd 3.2.1A~5.2.0.202305190958

=== Makefile ===
--- 
+++ 
@@ -165,7 +165,6 @@
 	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
 	$(Q)echo "- generating dynamic task files"
 	$(Q)set -e; cd $(TASKDIR); \
-		$(BASEDIR)/tools/update_tasks; \
 		$(BASEDIR)/tools/generate_di_list; \
 		$(BASEDIR)/tools/generate_di+k_list
 ifeq ($(FORCE_FIRMWARE),1)
@@ -251,7 +250,7 @@
 			fi; \
 		else \
 			$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
-			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
+			perl -000 -ne 's/^(Package: (\S+))$$/$$1\nStatus: install ok installed/m; print if (not $$seen{$$2}++ and (/^Priority: (required|important|standard)/m or /^Section: base/m));' \
 			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
@@ -268,7 +267,7 @@
 	$(Q)dpkg -x $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) $(ARCHIVE_KEYRING_PACKAGE)) $(TDIR)/archive-keyring
 	$(Q)for ARCH in $(ARCHES); do \
 		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
-		ln -s $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
+		ln -sf $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
 		for key in $(ARCHIVE_EXTRA_KEYS); do \
 			gpg --export -a $$key >> $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d/$$key.asc; \
 		done; \
@@ -325,13 +324,13 @@
 			export ARCH=$$ARCH; \
 			for i in `$(apt) deselected -f install`; do \
 				echo $$ARCH:$$i; \
-				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
+				perl -i -000 -ne "print unless /^Package: \Q$$i\E\$$/m" \
 				$(ADIR)/$(CODENAME)-$$ARCH/status; \
 			done; \
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				for i in `USE_BP=1 $(apt) deselected -f install`; do \
 					echo $$ARCH:$$i; \
-					perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
+					perl -i -000 -ne "print unless /^Package: \Q$$i\E$$/m" \
 					$(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
 				done; \
 			fi; \
@@ -343,19 +342,15 @@
 	if [ "$(ARCHES)" != "source" ] ; then \
 		for ARCH in $(ARCHES_NOSRC); do \
 			export ARCH=$$ARCH; \
-			for i in `$(apt) selected -f install`; do \
-				echo $$ARCH:$$i; \
-				$(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
-				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
+			$(apt) selected -f install | \
+			xargs --no-run-if-empty $(apt) cache --no-all-versions show "$$i" | \
+			perl -000 -npe "s/^(Package: \S+)\$$/\$$1\nStatus: install ok installed/m;" \
 				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
-			done; \
-			if [ "$$BACKPORTS"x != ""x ] ; then \
-				for i in `USE_BP=1 $(apt) selected -f install`; do \
-					echo $$ARCH:$$i; \
-					USE_BP=1 $(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
-					"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
+			if [ "$$BACKPORTS"x != ""x ] ; then \
+				USE_BP=1 $(apt) selected -f install | \
+				USE_BP=1 xargs --no-run-if-empty $(apt) cache --no-all-versions show "$$i" | \
+				perl -000 -npe "s/^(Package: \S+)\$$/\$$1\nStatus: install ok installed/m;" \
 					>> $(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
-				done; \
 			fi; \
 		done; \
     fi
@@ -379,3 +374,7 @@
 		done; \
     fi
 
+## GENERATING LISTS ##
+
+# Deleting the list only
+deletelist: ok

=== debian/changelog ===
debian-cd (3.2.1A~5.2.0.202305190958) ucs5-2-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    0001-Bug-35918-added-debug-output.patch
    0003-Replace-previous-sym-links.patch
    0004-Use-only-first-package-candidate.patch
    0005-Anchor-package-name-regular-expression.patch
    0006-Invoke-apt-cache-only-once.patch
    0007-Bug-38913-Drop-other-kernel-modules.patch
    0008-Bug-37008-DVD-Fix-relative-paths.patch
    0009-Bug-37008-DVD-Use-copy-as-fallback-for-hard-linking.patch
    0010-Bug-37164-DVD-Disable-Debian-task-rebuilding.patch
    0011-Bug-36268-DVD-Remove-Debian-specific-documentation.patch
    0013-Bug-45868-DVD-hard-code-component-main.patch

 -- Univention builddaemon <buildd@univention.de>  Fri, 19 May 2023 09:58:29 +0200

## debian-cd 3.2.2

=== Makefile ===
--- 
+++ 
@@ -70,7 +70,7 @@
 endif
 
 ## Additional packages required for Debian Ports
-DEBIAN_PORTS_ARCHES=alpha hppa ia64 hurd-i386 m68k powerpc powerpcspe ppc64 riscv64 sh4 sparc sparc64 x32
+DEBIAN_PORTS_ARCHES=alpha hppa ia64 hurd-amd64 hurd-i386 loong64 m68k powerpc powerpcspe ppc64 sh4 sparc sparc64 x32
 ifneq (,$(filter $(DEBIAN_PORTS_ARCHES),$(ARCHES)))
 export BASE_INCLUDE := $(BASEDIR)/data/debian_ports $(BASE_INCLUDE)
 endif
@@ -165,11 +165,12 @@
 	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
 	$(Q)echo "- generating dynamic task files"
 	$(Q)set -e; cd $(TASKDIR); \
+		$(BASEDIR)/tools/update_tasks; \
 		$(BASEDIR)/tools/generate_di_list; \
 		$(BASEDIR)/tools/generate_di+k_list
 ifeq ($(FORCE_FIRMWARE),1)
 	# Generate firmware task file using the contents of the archive
-	$(Q)$(BASEDIR)/tools/generate_firmware_task "$(ARCHES)" $(TASKDIR)/firmware
+	$(Q)$(BASEDIR)/tools/generate_firmware_task "$(ARCHES)" $(TASKDIR)/exclude-firmware $(TASKDIR)/firmware
 endif
 ifeq ($(DEBIAN_EDU),1)
 	# Generate Debian Edu task file containing (almost) all of Debian Edu's packages
@@ -190,14 +191,14 @@
 	fi
 endif
 
-# Make sure unstable/sid points to testing/bookworm, as there is no build
+# Make sure unstable/sid points to testing/trixie, as there is no build
 # rule for unstable/sid.
 unstable-map:
 	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
-		ln -s bookworm $(BASEDIR)/data/sid ; \
+		ln -s trixie $(BASEDIR)/data/sid ; \
 	fi
 	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
-		ln -s bookworm $(BASEDIR)/tools/boot/sid ; \
+		ln -s trixie $(BASEDIR)/tools/boot/sid ; \
 	fi
 
 #################
@@ -250,7 +251,7 @@
 			fi; \
 		else \
 			$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
-			perl -000 -ne 's/^(Package: (\S+))$$/$$1\nStatus: install ok installed/m; print if (not $$seen{$$2}++ and (/^Priority: (required|important|standard)/m or /^Section: base/m));' \
+			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
 			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				$(catz) $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.*z* | \
@@ -267,7 +268,7 @@
 	$(Q)dpkg -x $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) $(ARCHIVE_KEYRING_PACKAGE)) $(TDIR)/archive-keyring
 	$(Q)for ARCH in $(ARCHES); do \
 		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
-		ln -sf $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
+		ln -s $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
 		for key in $(ARCHIVE_EXTRA_KEYS); do \
 			gpg --export -a $$key >> $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d/$$key.asc; \
 		done; \
@@ -324,13 +325,13 @@
 			export ARCH=$$ARCH; \
 			for i in `$(apt) deselected -f install`; do \
 				echo $$ARCH:$$i; \
-				perl -i -000 -ne "print unless /^Package: \Q$$i\E\$$/m" \
+				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
 				$(ADIR)/$(CODENAME)-$$ARCH/status; \
 			done; \
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				for i in `USE_BP=1 $(apt) deselected -f install`; do \
 					echo $$ARCH:$$i; \
-					perl -i -000 -ne "print unless /^Package: \Q$$i\E$$/m" \
+					perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
 					$(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
 				done; \
 			fi; \
@@ -342,15 +343,19 @@
 	if [ "$(ARCHES)" != "source" ] ; then \
 		for ARCH in $(ARCHES_NOSRC); do \
 			export ARCH=$$ARCH; \
-			$(apt) selected -f install | \
-			xargs --no-run-if-empty $(apt) cache --no-all-versions show "$$i" | \
-			perl -000 -npe "s/^(Package: \S+)\$$/\$$1\nStatus: install ok installed/m;" \
+			for i in `$(apt) selected -f install`; do \
+				echo $$ARCH:$$i; \
+				$(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
+				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
 				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
-			if [ "$$BACKPORTS"x != ""x ] ; then \
-				USE_BP=1 $(apt) selected -f install | \
-				USE_BP=1 xargs --no-run-if-empty $(apt) cache --no-all-versions show "$$i" | \
-				perl -000 -npe "s/^(Package: \S+)\$$/\$$1\nStatus: install ok installed/m;" \
+			done; \
+			if [ "$$BACKPORTS"x != ""x ] ; then \
+				for i in `USE_BP=1 $(apt) selected -f install`; do \
+					echo $$ARCH:$$i; \
+					USE_BP=1 $(apt) cache --no-all-versions show "$$i" | perl -000 -npe \
+					"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m;" \
 					>> $(ADIR)/$(CODENAME)-backports-$$ARCH/status; \
+				done; \
 			fi; \
 		done; \
     fi
@@ -371,10 +376,3 @@
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				USE_BP=1 ARCH=$$ARCH $(apt) update; \
 			fi; \
-		done; \
-    fi
-
-## GENERATING LISTS ##
-
-# Deleting the list only
-deletelist: ok

=== debian/changelog ===
debian-cd (3.2.2-1kaisen) kaisen-packages; urgency=medium

  * Import new upstream release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 10 Aug 2025 02:34:47 +0200

debian-cd (3.2.2) unstable; urgency=medium

  [ Steve McIntyre ]
  * Start development for trixie
  * Remove old config and data for jessie and stretch
  * Add a way to exclude named firmware packages from media, so we can
    control which packages are included - see
    tasks/$codename/firmware-exclude. Closes: #1032071
  * Tweak sizes slightly for BD media.
  * Look for firmware in /usr/lib/firmware as well as /lib/firmware.
    Closes: #1059858
  * Fix counting of images at build time. Closes: #1063858
  * make_disc_trees.pl: if files will not fit on media, fail loudly
    rather than sitting in a loop forever. Fail properly in #1069682.
  * Add initial support for making riscv64 images
  * Cope with package name changes in udeb packages. Closes: #1084789.
  * Check that the first image has a linux-image-* package included,
    and abort if not.
  * tools/generate_di+k_list: Add explicit config to force tasksel and
    tasksel-data onto image 1
  * Multiple cleanups in make_disc_trees.pl:
    + Tweaks to logging
    + Reduce warnings
  * Multiple fixes for sources handling:
    + fix calls to apt-cache showsrc to ensure we get the correct
      source packages
    + Cope better with including multiple versions of source packages
  * Improved base package handling in tools/generate_di+k_list:
    + Factor out initial, busybox and zstd - all arches should have
      these.
    + For all arches, add bootloaders before the kernel image. This
      will more consistently succeed/fail in edge cases for sizing -
      we already check if we have a kernel included in the first image
      in make_disc_trees.pl.
  * Tweak how we including and excluding firmware packages
    + Make trixie armhf netinst fit again.

  [ Aurelien Jarno ]
  * Add support for UEFI booting on riscv64

  [ Guido Berhoerster ]
  * Update DebianEdu installer banner and syslinux splash image
    for bookworm

  [ Samuel Thibault ]
  * Add hurd-amd64 case.

  [ Arnaud Rebillout ]
  * Don't generate fw pattern file if DEP11 is set to 0
  * Support a fonts directory, and make *.pf2 optional

  [ dandan zhang ]
  * Add basic support for loongarch64

  [ Helge Deller ]
  * Dropped smp part of 64-bit hppa kernel

  [ Wolfgang Schweer ]
  * Update Debian-edu-full task file. (Closes: #1079261)

  [ Cyril Brulebois ]
  * Various firmware support updates:
    + Record firmware packages embedded in the modified initrds - see
      #1106005
    + Fix sound firmware inclusion logic for initrd
    + Add firmware-intel-sound alongside firmware-sof-signed
    + Add support for firmware-intel-sound patterns
  * Make sure systemd-cryptsetup is available - see #1092977

 -- Steve McIntyre <93sam@debian.org>  Mon, 12 Jun 2023 08:36:50 +0100

debian-cd (3.2.1-1kaisen) kaisen-packages; urgency=medium

  * Use a quilt package instead of native package
  * Import new upstream release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sat, 10 Aug 2024 22:10:04 +0200

debian-cd (3.1.35+kaisen3) kaisen-packages; urgency=medium

  * Add cryptsetup-initramfs in the tools/generate_di+k_list file

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 10 Mar 2022 16:21:36 +0200

debian-cd (3.1.35+kaisen2) kaisen-packages; urgency=medium

  * Change VOLID and DISKINFO variables values in tools/start_new_disc

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 01 Nov 2021 14:28:03 +0200

debian-cd (3.1.35+kaisen1) kaisen-packages; urgency=medium

  * Import new upstream release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 10 Oct 2021 22:07:27 +0200

debian-cd (3.1.33+kaisen1) kaisen-testing; urgency=medium

  * Rebuild to add kaisen-rolling symlinks

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 02 May 2021 00:55:22 +0200

=== debian/control ===
Source: debian-cd
Section: admin
Priority: optional
XSBC-Original-Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Maintainer: Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: tofrodos
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://gitlab.com/kaisenlinux/packages/debian-cd.git
Vcs-Browser: https://gitlab.com/kaisenlinux/packages/debian-cd

Package: debian-cd
Architecture: all
Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt, make, xorriso | genisoimage, lynx, grep-dctrl, bc, libcompress-zlib-perl, bzip2, libdpkg-perl, wget, libfile-slurp-perl, libyaml-libyaml-perl, uuid-runtime, pigz
Recommends: hfsutils, isolinux, syslinux-common, mtools, dosfstools
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD sets.

## debian-cd 3.2.3

=== Makefile ===
--- 
+++ 
@@ -21,12 +21,8 @@
 TASK=Debian-generic
 endif
 ifndef MKISOFS
-ifneq (,$(filter i386 amd64 arm64 hppa,$(ARCHES)))
 export MKISOFS=xorriso
 export MKISOFS_OPTS=-as mkisofs -r -checksum_algorithm_iso sha256,sha512
-else
-export MKISOFS=$(shell which genisoimage mkisofs | head -1)
-endif
 endif
 ifndef MKISOFS_OPTS
 #For normal users
@@ -376,3 +372,12 @@
 			if [ "$$BACKPORTS"x != ""x ] ; then \
 				USE_BP=1 ARCH=$$ARCH $(apt) update; \
 			fi; \
+		done; \
+    fi
+
+## GENERATING LISTS ##
+
+# Deleting the list only
+deletelist: ok
+	$(Q)-rm $(BDIR)/rawlist
+	$(Q)-rm $(BDIR)/list

=== debian/changelog ===
debian-cd (3.2.3) unstable; urgency=medium

  [ Steve McIntyre ]
  * Add linux-image-powerpc64le-64k for images - let's see if it fits.

  [ Ben Hutchings ]
  * Add linux-image-powerpc64-64k for images
  * Default to MKISOFS=xorriso for all architectures
    We've been assuming this in config for years already.

  [ Cyril Brulebois ]
  * Exclude more udebs to save some space on installation images:
     - fonts-*, libgtk2.0-0-udeb, xserver-xorg-input-libinput-udeb:
       included in graphical targets
     - wget-udeb (plus libcrypto3-udeb and libssl3-udeb): included via
       build/pkg-lists/base.
     - libgtk-3-0-udeb, libgtk-4-1-udeb, libvte-2.91-0-udeb: unused at the
       moment.

  [ Steve McIntyre ]
  * Start development for forky

  [ Roland Clobus ]
  * arm64 udebs: include 'netcfg' and friends

 -- Steve McIntyre <93sam@debian.org>  Sat, 26 Jul 2025 13:18:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,17 @@
 Source: debian-cd
 Section: admin
 Priority: optional
-XSBC-Original-Maintainer: Debian CD Group <debian-cd@lists.debian.org>
-Maintainer: Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>
+Maintainer: Debian CD Group <debian-cd@lists.debian.org>
+Uploaders: Raphaël Hertzog <hertzog@debian.org>,
+ Santiago Garcia Mantinan <manty@debian.org>,
+ Steve McIntyre <93sam@debian.org>,
+ Holger Levsen <holger@debian.org>
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Indep: tofrodos
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Vcs-Git: https://gitlab.com/kaisenlinux/packages/debian-cd.git
-Vcs-Browser: https://gitlab.com/kaisenlinux/packages/debian-cd
+Vcs-Git: https://salsa.debian.org/images-team/debian-cd.git
+Vcs-Browser: https://salsa.debian.org/images-team/debian-cd
 
 Package: debian-cd
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# #export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	:

override_dh_auto_install:
	dh_install
	# dh_install cannot rename files
	cp CONF.sh debian/debian-cd/etc/debian-cd/conf.sh
